// Code generated by msgraph.go/gen DO NOT EDIT.

package msgraph

import "time"

// IntuneBrand undocumented
type IntuneBrand struct {
	// Object is the base model of IntuneBrand
	Object
	// DisplayName Company/organization name that is displayed to end users.
	DisplayName *string `json:"displayName,omitempty"`
	// ThemeColor Primary theme color used in the Company Portal applications and web portal.
	ThemeColor *RgbColor `json:"themeColor,omitempty"`
	// ShowLogo Boolean that represents whether the administrator-supplied logo images are shown or not shown.
	ShowLogo *bool `json:"showLogo,omitempty"`
	// LightBackgroundLogo Logo image displayed in Company Portal apps which have a light background behind the logo.
	LightBackgroundLogo *MimeContent `json:"lightBackgroundLogo,omitempty"`
	// DarkBackgroundLogo Logo image displayed in Company Portal apps which have a dark background behind the logo.
	DarkBackgroundLogo *MimeContent `json:"darkBackgroundLogo,omitempty"`
	// ShowNameNextToLogo Boolean that represents whether the administrator-supplied display name will be shown next to the logo image.
	ShowNameNextToLogo *bool `json:"showNameNextToLogo,omitempty"`
	// LandingPageCustomizedImage Customized image displayed in Company Portal app landing page
	LandingPageCustomizedImage *MimeContent `json:"landingPageCustomizedImage,omitempty"`
	// ShowDisplayNameNextToLogo Boolean that represents whether the administrator-supplied display name will be shown next to the logo image.
	ShowDisplayNameNextToLogo *bool `json:"showDisplayNameNextToLogo,omitempty"`
	// ContactITName Name of the person/organization responsible for IT support.
	ContactITName *string `json:"contactITName,omitempty"`
	// ContactITPhoneNumber Phone number of the person/organization responsible for IT support.
	ContactITPhoneNumber *string `json:"contactITPhoneNumber,omitempty"`
	// ContactITEmailAddress Email address of the person/organization responsible for IT support.
	ContactITEmailAddress *string `json:"contactITEmailAddress,omitempty"`
	// ContactITNotes Text comments regarding the person/organization responsible for IT support.
	ContactITNotes *string `json:"contactITNotes,omitempty"`
	// OnlineSupportSiteURL URL to the company/organization’s IT helpdesk site.
	OnlineSupportSiteURL *string `json:"onlineSupportSiteUrl,omitempty"`
	// OnlineSupportSiteName Display name of the company/organization’s IT helpdesk site.
	OnlineSupportSiteName *string `json:"onlineSupportSiteName,omitempty"`
	// PrivacyURL URL to the company/organization’s privacy policy.
	PrivacyURL *string `json:"privacyUrl,omitempty"`
	// CustomPrivacyMessage Custom privacy message.
	CustomPrivacyMessage *string `json:"customPrivacyMessage,omitempty"`
	// IsRemoveDeviceDisabled Boolean that represents whether the adminsistrator has disabled the 'Remove Device' action on corporate owned devices.
	IsRemoveDeviceDisabled *bool `json:"isRemoveDeviceDisabled,omitempty"`
	// IsFactoryResetDisabled Boolean that represents whether the adminsistrator has disabled the 'Factory Reset' action on corporate owned devices.
	IsFactoryResetDisabled *bool `json:"isFactoryResetDisabled,omitempty"`
	// CompanyPortalBlockedActions Collection of blocked actions on the company portal as per platform and device ownership types.
	CompanyPortalBlockedActions []CompanyPortalBlockedAction `json:"companyPortalBlockedActions,omitempty"`
	// ShowAzureADEnterpriseApps Boolean that indicates if AzureAD Enterprise Apps will be shown in Company Portal
	ShowAzureADEnterpriseApps *bool `json:"showAzureADEnterpriseApps,omitempty"`
	// ShowOfficeWebApps Boolean that indicates if Office WebApps will be shown in Company Portal
	ShowOfficeWebApps *bool `json:"showOfficeWebApps,omitempty"`
}

// IntuneBrandingProfile This entity contains data which is used in customizing the tenant level appearance of the Company Portal applications as well as the end user web portal.
type IntuneBrandingProfile struct {
	// Entity is the base model of IntuneBrandingProfile
	Entity
	// ProfileName Name of the profile
	ProfileName *string `json:"profileName,omitempty"`
	// ProfileDescription Description of the profile
	ProfileDescription *string `json:"profileDescription,omitempty"`
	// IsDefaultProfile Boolean that represents whether the profile is used as default or not
	IsDefaultProfile *bool `json:"isDefaultProfile,omitempty"`
	// CreatedDateTime Time when the BrandingProfile was created
	CreatedDateTime *time.Time `json:"createdDateTime,omitempty"`
	// LastModifiedDateTime Time when the BrandingProfile was last modified
	LastModifiedDateTime *time.Time `json:"lastModifiedDateTime,omitempty"`
	// DisplayName Company/organization name that is displayed to end users
	DisplayName *string `json:"displayName,omitempty"`
	// ThemeColor Primary theme color used in the Company Portal applications and web portal
	ThemeColor *RgbColor `json:"themeColor,omitempty"`
	// ShowLogo Boolean that represents whether the administrator-supplied logo images are shown or not
	ShowLogo *bool `json:"showLogo,omitempty"`
	// ShowDisplayNameNextToLogo Boolean that represents whether the administrator-supplied display name will be shown next to the logo image or not
	ShowDisplayNameNextToLogo *bool `json:"showDisplayNameNextToLogo,omitempty"`
	// ThemeColorLogo Logo image displayed in Company Portal apps which have a theme color background behind the logo
	ThemeColorLogo *MimeContent `json:"themeColorLogo,omitempty"`
	// LightBackgroundLogo Logo image displayed in Company Portal apps which have a light background behind the logo
	LightBackgroundLogo *MimeContent `json:"lightBackgroundLogo,omitempty"`
	// LandingPageCustomizedImage Customized image displayed in Company Portal apps landing page
	LandingPageCustomizedImage *MimeContent `json:"landingPageCustomizedImage,omitempty"`
	// ContactITName Name of the person/organization responsible for IT support
	ContactITName *string `json:"contactITName,omitempty"`
	// ContactITPhoneNumber Phone number of the person/organization responsible for IT support
	ContactITPhoneNumber *string `json:"contactITPhoneNumber,omitempty"`
	// ContactITEmailAddress E-mail address of the person/organization responsible for IT support
	ContactITEmailAddress *string `json:"contactITEmailAddress,omitempty"`
	// ContactITNotes Text comments regarding the person/organization responsible for IT support
	ContactITNotes *string `json:"contactITNotes,omitempty"`
	// OnlineSupportSiteURL URL to the company/organization’s IT helpdesk site
	OnlineSupportSiteURL *string `json:"onlineSupportSiteUrl,omitempty"`
	// OnlineSupportSiteName Display name of the company/organization’s IT helpdesk site
	OnlineSupportSiteName *string `json:"onlineSupportSiteName,omitempty"`
	// PrivacyURL URL to the company/organization’s privacy policy
	PrivacyURL *string `json:"privacyUrl,omitempty"`
	// CustomPrivacyMessage Text comments regarding what the admin has access to on the device
	CustomPrivacyMessage *string `json:"customPrivacyMessage,omitempty"`
	// IsRemoveDeviceDisabled Boolean that represents whether the adminsistrator has disabled the 'Remove Device' action on corporate owned devices.
	IsRemoveDeviceDisabled *bool `json:"isRemoveDeviceDisabled,omitempty"`
	// IsFactoryResetDisabled Boolean that represents whether the adminsistrator has disabled the 'Factory Reset' action on corporate owned devices.
	IsFactoryResetDisabled *bool `json:"isFactoryResetDisabled,omitempty"`
	// CompanyPortalBlockedActions Collection of blocked actions on the company portal as per platform and device ownership types.
	CompanyPortalBlockedActions []CompanyPortalBlockedAction `json:"companyPortalBlockedActions,omitempty"`
	// ShowAzureADEnterpriseApps Boolean that indicates if AzureAD Enterprise Apps will be shown in Company Portal
	ShowAzureADEnterpriseApps *bool `json:"showAzureADEnterpriseApps,omitempty"`
	// ShowOfficeWebApps Boolean that indicates if Office WebApps will be shown in Company Portal
	ShowOfficeWebApps *bool `json:"showOfficeWebApps,omitempty"`
	// Assignments undocumented
	Assignments []IntuneBrandingProfileAssignment `json:"assignments,omitempty"`
}

// IntuneBrandingProfileAssignment This entity contains the properties used to assign a branding profile to a group.
type IntuneBrandingProfileAssignment struct {
	// Entity is the base model of IntuneBrandingProfileAssignment
	Entity
	// Target Assignment target that the branding profile is assigned to.
	Target *DeviceAndAppManagementAssignmentTarget `json:"target,omitempty"`
}
