// Code generated by msgraph.go/gen DO NOT EDIT.

package msgraph

import "time"

// RemoteActionAudit Report of remote actions initiated on the devices belonging to a certain tenant.
type RemoteActionAudit struct {
	// Entity is the base model of RemoteActionAudit
	Entity
	// DeviceDisplayName Intune device name.
	DeviceDisplayName *string `json:"deviceDisplayName,omitempty"`
	// UserName [deprecated] Please use InitiatedByUserPrincipalName instead.
	UserName *string `json:"userName,omitempty"`
	// InitiatedByUserPrincipalName User who initiated the device action, format is UPN.
	InitiatedByUserPrincipalName *string `json:"initiatedByUserPrincipalName,omitempty"`
	// Action The action name.
	Action *RemoteAction `json:"action,omitempty"`
	// RequestDateTime Time when the action was issued, given in UTC.
	RequestDateTime *time.Time `json:"requestDateTime,omitempty"`
	// DeviceOwnerUserPrincipalName Upn of the device owner.
	DeviceOwnerUserPrincipalName *string `json:"deviceOwnerUserPrincipalName,omitempty"`
	// DeviceIMEI IMEI of the device.
	DeviceIMEI *string `json:"deviceIMEI,omitempty"`
	// ActionState Action state.
	ActionState *ActionState `json:"actionState,omitempty"`
	// ManagedDeviceID Action target.
	ManagedDeviceID *string `json:"managedDeviceId,omitempty"`
}

// RemoteAssistancePartner RemoteAssistPartner resources represent the metadata and status of a given Remote Assistance partner service.
type RemoteAssistancePartner struct {
	// Entity is the base model of RemoteAssistancePartner
	Entity
	// DisplayName Display name of the partner.
	DisplayName *string `json:"displayName,omitempty"`
	// OnboardingURL URL of the partner's onboarding portal, where an administrator can configure their Remote Assistance service.
	OnboardingURL *string `json:"onboardingUrl,omitempty"`
	// OnboardingStatus A friendly description of the current TeamViewer connector status
	OnboardingStatus *RemoteAssistanceOnboardingStatus `json:"onboardingStatus,omitempty"`
	// LastConnectionDateTime Timestamp of the last request sent to Intune by the TEM partner.
	LastConnectionDateTime *time.Time `json:"lastConnectionDateTime,omitempty"`
}

// RemoteItem undocumented
type RemoteItem struct {
	// Object is the base model of RemoteItem
	Object
	// CreatedBy undocumented
	CreatedBy *IdentitySet `json:"createdBy,omitempty"`
	// CreatedDateTime undocumented
	CreatedDateTime *time.Time `json:"createdDateTime,omitempty"`
	// File undocumented
	File *File `json:"file,omitempty"`
	// FileSystemInfo undocumented
	FileSystemInfo *FileSystemInfo `json:"fileSystemInfo,omitempty"`
	// Folder undocumented
	Folder *Folder `json:"folder,omitempty"`
	// ID undocumented
	ID *string `json:"id,omitempty"`
	// LastModifiedBy undocumented
	LastModifiedBy *IdentitySet `json:"lastModifiedBy,omitempty"`
	// LastModifiedDateTime undocumented
	LastModifiedDateTime *time.Time `json:"lastModifiedDateTime,omitempty"`
	// Name undocumented
	Name *string `json:"name,omitempty"`
	// Package undocumented
	Package *Package `json:"package,omitempty"`
	// ParentReference undocumented
	ParentReference *ItemReference `json:"parentReference,omitempty"`
	// Shared undocumented
	Shared *Shared `json:"shared,omitempty"`
	// SharepointIDs undocumented
	SharepointIDs *SharepointIDs `json:"sharepointIds,omitempty"`
	// Size undocumented
	Size *int `json:"size,omitempty"`
	// SpecialFolder undocumented
	SpecialFolder *SpecialFolder `json:"specialFolder,omitempty"`
	// WebDavURL undocumented
	WebDavURL *string `json:"webDavUrl,omitempty"`
	// WebURL undocumented
	WebURL *string `json:"webUrl,omitempty"`
}

// RemoteLockActionResult undocumented
type RemoteLockActionResult struct {
	// DeviceActionResult is the base model of RemoteLockActionResult
	DeviceActionResult
	// UnlockPin Pin to unlock the client
	UnlockPin *string `json:"unlockPin,omitempty"`
}
